AppTitle "Double Layer Tile Rendering by Eikon"
Graphics 320, 240, 16, 2
SetBuffer BackBuffer()

Dim Map(1, 99, 14) ; Tile Array
                   ; Slot one has 2 places, 0 and 1, these are our two layers
                   ; Slot two can hold 100 horizontal tiles (5 screen fulls)
                   ; Slot three can hold 15 vertical tiles (screen height)

; Tileset
img_Tiles = LoadAnimImage("tiles.bmp", 16, 16, 0, 2): MaskImage img_Tiles, 255, 0, 255

; Populate Array with Random Values
For i = 0 To 1                     ; Layer Loop
	For y = 0 To 14                ; Y Loop
		For x = 0 To 99            ; X Loop
			If Rand(1, 3) = 2 Then ; Random Tile
				Map(i, x, y) = Rand(0, 1) 
			Else                    ; Empty Tile
				Map(i, x, y) = -1
			EndIf
		Next
	Next
Next

X_Off = 0 ; X Tile OffSet (for Scrolling)

While Not KeyDown(1)

For i = 0 To 1                      ; Layer Loop
	tmp_X = 0: tmp_Y = 0
	For y = 0 To 14                 ; Y Loop
		For x = X_Off To X_Off + 20 ; X Loop
			If Map(i, x, y) <> -1 Then DrawImage img_Tiles, tmp_X, tmp_Y, Map(i, x, y) ; Render Tile
			tmp_X = tmp_X + 16
		Next
		tmp_Y = tmp_Y + 16: tmp_X = 0
	Next	
Next

Text 1, 1, X_Off
If KeyDown(205) And X_Off < 79 Then X_Off = X_Off + 1
If KeyDown(203) And X_Off > 0 Then X_Off = X_Off - 1

Flip: Cls
Wend: End